#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n, s;
int dp[20005];
int a[20005];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    memset(dp, -1, sizeof(dp));
    dp[0]=0;
    cin>>s>>n;
    for(int i=0; i<n; i++) cin>>a[i];
    sort(a, a+n);
    for(int i=0; i<n; i++)
    {
        for(int j=a[i]; j<=20000; j++)
        {
            if(dp[j-a[i]]==-1) continue;
            if(dp[j]==-1 || dp[j]>dp[j-a[i]]+1) dp[j]=dp[j-a[i]]+1;
        }
    }
    cout<<dp[s]<<endl;
    return 0;
}
